# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from .. import utilities, tables

class Budget(pulumi.CustomResource):
    all_updates_rule: pulumi.Output[dict]
    """
    Defines notifications that are sent on every update to the billing account's spend, regardless of the thresholds defined
    using threshold rules.

      * `pubsubTopic` (`str`)
      * `schemaVersion` (`str`)
    """
    amount: pulumi.Output[dict]
    """
    The budgeted amount for each usage period.

      * `specifiedAmount` (`dict`)
        * `currencyCode` (`str`)
        * `nanos` (`float`)
        * `units` (`str`)
    """
    billing_account: pulumi.Output[str]
    """
    ID of the billing account to set a budget on.
    """
    budget_filter: pulumi.Output[dict]
    """
    Filters that define which resources are used to compute the actual spend against the budget.

      * `creditTypesTreatment` (`str`)
      * `projects` (`list`)
      * `services` (`list`)
    """
    display_name: pulumi.Output[str]
    """
    User data for display name in UI. Must be <= 60 chars.
    """
    name: pulumi.Output[str]
    """
    Resource name of the budget. The resource name implies the scope of a budget. Values are of the form
    billingAccounts/{billingAccountId}/budgets/{budgetId}.
    """
    threshold_rules: pulumi.Output[list]
    """
    Rules that trigger alerts (notifications of thresholds being crossed) when spend exceeds the specified percentages of
    the budget.

      * `spendBasis` (`str`)
      * `thresholdPercent` (`float`)
    """
    def __init__(__self__, resource_name, opts=None, all_updates_rule=None, amount=None, billing_account=None, budget_filter=None, display_name=None, threshold_rules=None, __props__=None, __name__=None, __opts__=None):
        """
        Budget configuration for a billing account.

        To get more information about Budget, see:

        * [API documentation](https://cloud.google.com/billing/docs/reference/budget/rest/v1beta1/billingAccounts.budgets)
        * How-to Guides
            * [Creating a budget](https://cloud.google.com/billing/docs/how-to/budgets)

        > This content is derived from https://github.com/terraform-providers/terraform-provider-google/blob/master/website/docs/r/billing_budget.html.markdown.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[dict] all_updates_rule: Defines notifications that are sent on every update to the billing account's spend, regardless of the thresholds defined
               using threshold rules.
        :param pulumi.Input[dict] amount: The budgeted amount for each usage period.
        :param pulumi.Input[str] billing_account: ID of the billing account to set a budget on.
        :param pulumi.Input[dict] budget_filter: Filters that define which resources are used to compute the actual spend against the budget.
        :param pulumi.Input[str] display_name: User data for display name in UI. Must be <= 60 chars.
        :param pulumi.Input[list] threshold_rules: Rules that trigger alerts (notifications of thresholds being crossed) when spend exceeds the specified percentages of
               the budget.

        The **all_updates_rule** object supports the following:

          * `pubsubTopic` (`pulumi.Input[str]`)
          * `schemaVersion` (`pulumi.Input[str]`)

        The **amount** object supports the following:

          * `specifiedAmount` (`pulumi.Input[dict]`)
            * `currencyCode` (`pulumi.Input[str]`)
            * `nanos` (`pulumi.Input[float]`)
            * `units` (`pulumi.Input[str]`)

        The **budget_filter** object supports the following:

          * `creditTypesTreatment` (`pulumi.Input[str]`)
          * `projects` (`pulumi.Input[list]`)
          * `services` (`pulumi.Input[list]`)

        The **threshold_rules** object supports the following:

          * `spendBasis` (`pulumi.Input[str]`)
          * `thresholdPercent` (`pulumi.Input[float]`)
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['all_updates_rule'] = all_updates_rule
            if amount is None:
                raise TypeError("Missing required property 'amount'")
            __props__['amount'] = amount
            if billing_account is None:
                raise TypeError("Missing required property 'billing_account'")
            __props__['billing_account'] = billing_account
            __props__['budget_filter'] = budget_filter
            __props__['display_name'] = display_name
            if threshold_rules is None:
                raise TypeError("Missing required property 'threshold_rules'")
            __props__['threshold_rules'] = threshold_rules
            __props__['name'] = None
        super(Budget, __self__).__init__(
            'gcp:billing/budget:Budget',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, all_updates_rule=None, amount=None, billing_account=None, budget_filter=None, display_name=None, name=None, threshold_rules=None):
        """
        Get an existing Budget resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[dict] all_updates_rule: Defines notifications that are sent on every update to the billing account's spend, regardless of the thresholds defined
               using threshold rules.
        :param pulumi.Input[dict] amount: The budgeted amount for each usage period.
        :param pulumi.Input[str] billing_account: ID of the billing account to set a budget on.
        :param pulumi.Input[dict] budget_filter: Filters that define which resources are used to compute the actual spend against the budget.
        :param pulumi.Input[str] display_name: User data for display name in UI. Must be <= 60 chars.
        :param pulumi.Input[str] name: Resource name of the budget. The resource name implies the scope of a budget. Values are of the form
               billingAccounts/{billingAccountId}/budgets/{budgetId}.
        :param pulumi.Input[list] threshold_rules: Rules that trigger alerts (notifications of thresholds being crossed) when spend exceeds the specified percentages of
               the budget.

        The **all_updates_rule** object supports the following:

          * `pubsubTopic` (`pulumi.Input[str]`)
          * `schemaVersion` (`pulumi.Input[str]`)

        The **amount** object supports the following:

          * `specifiedAmount` (`pulumi.Input[dict]`)
            * `currencyCode` (`pulumi.Input[str]`)
            * `nanos` (`pulumi.Input[float]`)
            * `units` (`pulumi.Input[str]`)

        The **budget_filter** object supports the following:

          * `creditTypesTreatment` (`pulumi.Input[str]`)
          * `projects` (`pulumi.Input[list]`)
          * `services` (`pulumi.Input[list]`)

        The **threshold_rules** object supports the following:

          * `spendBasis` (`pulumi.Input[str]`)
          * `thresholdPercent` (`pulumi.Input[float]`)
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["all_updates_rule"] = all_updates_rule
        __props__["amount"] = amount
        __props__["billing_account"] = billing_account
        __props__["budget_filter"] = budget_filter
        __props__["display_name"] = display_name
        __props__["name"] = name
        __props__["threshold_rules"] = threshold_rules
        return Budget(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

